#define IMGUI_DISABLE_INCLUDE_IMCONFIG_H
#define IMGUI_HAS_DOCK 1

#include "CommonHeaders.h"
#include "HotkeysManager.h"
#include "OSDManager.h"
#include <chrono>

// Screen informations
static int screenWidth = GetSystemMetrics(SM_CXSCREEN);
static int screenHeight = GetSystemMetrics(SM_CYSCREEN);
static float aspectRatio = (float)screenWidth / screenHeight;

// Core game dll functions declarations
using SetBoolFn = void (*)(bool, bool);
using SetFixesFn = void (*)(GameFixes, bool);
using SetFloatFn = void (*)(GameSetting, float);

static HMODULE fixLib = nullptr;
static LONG g_coreInitialized = 0;
static LONG g_hotkeysInitialized = 0;
static LONG g_uniformReseted = 0;
static SetBoolFn SetFixEnabled = nullptr;
static SetFixesFn SetFixes = nullptr;
static SetFloatFn SetValues = nullptr;
static GetGameInfosStruct GetGameInfos = nullptr;
void SetFixesEnabled(GameFixes fix, bool value) { if (SetFixes) SetFixes(fix, value); }

// Plugin variables for checkboxes and sliders
static bool skip_Intro_enabled = false;
static bool fov_fix_enabled = false;
static bool Aspect_fix_enabled = false;
static bool DOF_fix_enabled = false;
static bool Vignetting_fix_enabled = false;
static bool Fog_fix_enabled = false;
static bool camera_Distance_fix_enabled = false;
static bool HUD_fix_enabled = false;
static bool fix_enabled = false;
static bool Time_Dilation_fix_enabled = false;
static bool Ignore_hits_fix_enabled = false;
static bool StealthMode_fix_enabled = false;
static bool GodMode_fix_enabled = false;
static int worldFOVvalue = 0;
static int HUDvalue = 0;
static int UIvalue = 0;
static float cameraDistancevalue = 0.f;
static float worldTimeDilationValue = 1.f;
static float AITimeDilationValue = 1.f;
static bool console = true;
static float OSD_duration = 3.f;

// Overlays popups
static bool popup_Informations = false;
static bool show_log_overlay = false;
static std::string log_content;

// Plugin settings
const std::string SETTINGS_FILE = "./pluginsettings.ini";
const char* FIX_VERSION = "1.0.8";
const char* FIX_INFORMATIONS = "This fix allows to:\n - Control FOV in game.\n - Unlock ultrawide resolutions.\n - Control camera distance.\n - Control HUD scaling.\n - Remove depth of field.\n - Remove vignetting.\n - Remove fog.\n - Re enable console.\n - Enable cheats";
const char* DONATION_URL = "https://buymeacoffee.com/k4sh44";

// Prepare arrays of checkboxes for ImGui
static FixToggle individualFixes[] = {
    { "FOV", &fov_fix_enabled, GameFixes::FOV },
    { "Vignetting", &Vignetting_fix_enabled, GameFixes::Vignetting },
    { "Fog", &Fog_fix_enabled, GameFixes::Fog },
    { "Ultrawide", &Aspect_fix_enabled, GameFixes::UltraWide, "This is intended for ultrawide only.\n"
                                                              "Set panini to off in settings to avoid blurry textures and narrow FOV."},
    { "Camera distance", &camera_Distance_fix_enabled, GameFixes::Camera },
    { "HUD & UI", &HUD_fix_enabled, GameFixes::HUD },
    { "Depth of field", &DOF_fix_enabled, GameFixes::DOF }
};

static FixToggle cheatFixes[] = {
    { "Time dilation", &Time_Dilation_fix_enabled, GameFixes::TimeDilation, "ALT + 1 (top keyboard row) to toggle" },
    { "God mode", &GodMode_fix_enabled, GameFixes::GodMode, "ALT + 2 (top keyboard row) to toggle.\nTraveler won't receive any damage." },
    { "Ignore hits", &Ignore_hits_fix_enabled, GameFixes::IgnoreHits, "ALT + 3 (top keyboard row) to toggle.\nTraveler can't be hit but still can be grabbed." },
    { "Stealth mode",&StealthMode_fix_enabled, GameFixes::Stealth, "ALT + 4 (top keyboard row) to toggle.\nEnemies won't attack you except scripted ones." }
};

// Facteur de scaling basé sur la résolution verticale
float scale = (float)screenHeight / 1200;
// Prepare array of sliders for ImGui
static SliderFix2 sliders[6];

// Load and unload game core dll functions /!\ necessary
static void LoadFixDLL() {
    if (InterlockedCompareExchange(&g_coreInitialized, 1, 0) != 0)
        return;

    if (GetModuleHandleA("CronosTNDCore.dll") == nullptr) {
        fixLib = LoadLibraryA("CronosTNDCore.dll");

        if (!fixLib) {
            MessageBoxA(nullptr, "Impossible to load game core dll", "Erreur", MB_OK);
            return;
        }

        SetFixEnabled = (SetBoolFn)GetProcAddress(fixLib, "SetFixEnabled");
        SetFixes = (SetFixesFn)GetProcAddress(fixLib, "SetFixesEnabled");
        SetValues = (SetFloatFn)GetProcAddress(fixLib, "SetValues");
        GetGameInfos = (GetGameInfosStruct)GetProcAddress(fixLib, "GetGameInfos");

        // Apply initial values loaded from settings
        if (SetValues) {
            SetValues(GameSetting::FOV, worldFOVvalue);
            SetValues(GameSetting::CameraDistance, cameraDistancevalue);
            SetValues(GameSetting::HUD, HUDvalue);
            SetValues(GameSetting::UI, UIvalue);
            SetValues(GameSetting::WorldTimeDilation, worldTimeDilationValue);
            SetValues(GameSetting::AITimeDilation, AITimeDilationValue);
        }
        if (SetFixEnabled) SetFixEnabled(fix_enabled, true);
        if (SetFixes) {
            SetFixes(GameFixes::SkipIntro, skip_Intro_enabled);
            SetFixes(GameFixes::FOV, fov_fix_enabled);
            SetFixes(GameFixes::UltraWide, Aspect_fix_enabled);
            SetFixes(GameFixes::Camera, camera_Distance_fix_enabled);
            SetFixes(GameFixes::HUD, HUD_fix_enabled);
            SetFixes(GameFixes::DOF, DOF_fix_enabled);
            SetFixes(GameFixes::Vignetting, Vignetting_fix_enabled);
            SetFixes(GameFixes::Fog, Fog_fix_enabled);
            SetFixes(GameFixes::TimeDilation, Time_Dilation_fix_enabled);
            SetFixes(GameFixes::GodMode, GodMode_fix_enabled);
            SetFixes(GameFixes::IgnoreHits, Ignore_hits_fix_enabled);
            SetFixes(GameFixes::Stealth, StealthMode_fix_enabled);
            SetFixes(GameFixes::DevConsole, console);
        }

        sliders[0] = { "In game additional FOV", "##FOVValue", SliderType::Int, &worldFOVvalue, -20, 70, GameSetting::FOV, SetValues };
        sliders[1] = { "Camera distance (*)", "##CameraOffset", SliderType::Float, &cameraDistancevalue, 0, 4, GameSetting::CameraDistance, SetValues, "%.2f",
                       "Value is a multiplier.\nAffects both normal and weapon aiming distance." };
        sliders[2] = { "HUD scaling", "##HUDValue", SliderType::Int, &HUDvalue, 0, 40, GameSetting::HUD, SetValues, nullptr, "This will only affect HUD"};
        sliders[3] = { "UI scaling", "##UIValue", SliderType::Int, &UIvalue, 0, 40, GameSetting::UI, SetValues, nullptr, "This will only affect UI (menus)" };
        sliders[4] = { "World time dilation", "##WorldTimeDilationValue", SliderType::Float, &worldTimeDilationValue, 0.f, 3.f, GameSetting::WorldTimeDilation, SetValues, "%.1f",
                       "Will affect everything in the world.\nDefault value is 1." };
        sliders[5] = { "AI time dilation", "##AITimeDilationValue", SliderType::Float, &AITimeDilationValue, 0.f, 2.f, GameSetting::AITimeDilation, SetValues, "%.1f",
                       "Will affect only enemies in the world.\nDefault value is 1." };
    }
}

// Settings functions
static void SaveSettings() {
    ini::IniFile pluginIniFile;
    pluginIniFile["1#General fix"].setComment(std::vector<std::string>{ "The following sections are saved by plugin",
                                                                        "You should not need to modify them",
                                                                        " ",
                                                                        "Controls if fix mod (globally) is enabled",
                                                                        "Set Console to false if you don't want to enable it",
                                                                        "Set Skip Intro to false if you don't wan't to skip them" });
    pluginIniFile["1#General fix"]["Enabled"] = fix_enabled;
    pluginIniFile["1#General fix"]["Console"] = console;
    pluginIniFile["1#General fix"]["Skip Intro"] = skip_Intro_enabled;
    pluginIniFile["2#Individual fix"].setComment("Controls each fix individually");
    pluginIniFile["2#Individual fix"]["FOV"] = fov_fix_enabled;
    pluginIniFile["2#Individual fix"]["UltraWide"] = Aspect_fix_enabled;
    pluginIniFile["2#Individual fix"]["Camera"] = camera_Distance_fix_enabled;
    pluginIniFile["2#Individual fix"]["HUD"] = HUD_fix_enabled;
    pluginIniFile["2#Individual fix"]["DOF"] = DOF_fix_enabled;
    pluginIniFile["2#Individual fix"]["Vignetting"] = Vignetting_fix_enabled;
    pluginIniFile["2#Individual fix"]["Fog"] = Fog_fix_enabled;
    pluginIniFile["2#Individual fix"]["Time dilation"] = Time_Dilation_fix_enabled;
    pluginIniFile["2#Individual fix"]["God Mode"] = GodMode_fix_enabled;
    pluginIniFile["2#Individual fix"]["Ignore hits"] = Ignore_hits_fix_enabled;
    pluginIniFile["2#Individual fix"]["Stealth"] = StealthMode_fix_enabled;
    pluginIniFile["3#Fixes tuning"].setComment("Individual fix fine tune");
    pluginIniFile["3#Fixes tuning"]["World FOV"] = worldFOVvalue;
    pluginIniFile["3#Fixes tuning"]["Camera distance"] = cameraDistancevalue;
    pluginIniFile["3#Fixes tuning"]["HUD scaling"] = HUDvalue;
    pluginIniFile["3#Fixes tuning"]["UI scaling"] = UIvalue;
    pluginIniFile["3#Fixes tuning"]["World time dilation scale"] = worldTimeDilationValue;
    pluginIniFile["3#Fixes tuning"]["AI time dilation scale"] = AITimeDilationValue;

    pluginIniFile.save(SETTINGS_FILE);
}

static void LoadSettings() {
    ini::IniFile pluginIniFile;
    try {
        pluginIniFile.load(SETTINGS_FILE);
        fix_enabled                 = pluginIniFile["1#General fix"]["Enabled"].as<bool>();
        console                     = pluginIniFile["1#General fix"]["Console"].as<bool>();
        skip_Intro_enabled          = pluginIniFile["1#General fix"]["Skip Intro"].as<bool>();
        fov_fix_enabled             = pluginIniFile["2#Individual fix"]["FOV"].as<bool>();
        Aspect_fix_enabled          = pluginIniFile["2#Individual fix"]["UltraWide"].as<bool>();
        camera_Distance_fix_enabled = pluginIniFile["2#Individual fix"]["Camera"].as<bool>();
        HUD_fix_enabled             = pluginIniFile["2#Individual fix"]["HUD"].as<bool>();
        DOF_fix_enabled             = pluginIniFile["2#Individual fix"]["DOF"].as<bool>();
        Vignetting_fix_enabled      = pluginIniFile["2#Individual fix"]["Vignetting"].as<bool>();
        Fog_fix_enabled             = pluginIniFile["2#Individual fix"]["Fog"].as<bool>();
        Time_Dilation_fix_enabled   = pluginIniFile["2#Individual fix"]["Time dilation"].as<bool>();
        GodMode_fix_enabled         = pluginIniFile["2#Individual fix"]["God Mode"].as<bool>();
        Ignore_hits_fix_enabled     = pluginIniFile["2#Individual fix"]["Ignore hits"].as<bool>();
        StealthMode_fix_enabled     = pluginIniFile["2#Individual fix"]["Stealth"].as<bool>();
        worldFOVvalue               = pluginIniFile["3#Fixes tuning"]["World FOV"].as<int>();
        cameraDistancevalue         = pluginIniFile["3#Fixes tuning"]["Camera distance"].as<float>();
        HUDvalue                    = pluginIniFile["3#Fixes tuning"]["HUD scaling"].as<float>();
        UIvalue                     = pluginIniFile["3#Fixes tuning"]["UI scaling"].as<float>();
        worldTimeDilationValue      = pluginIniFile["3#Fixes tuning"]["World time dilation scale"].as<float>();
        AITimeDilationValue         = pluginIniFile["3#Fixes tuning"]["AI time dilation scale"].as<float>();
    }
    catch (const std::exception& e) {}
}

// Read plugin log file
void read_log_file(const std::string& filename) {
    std::ifstream file(filename);
    if (!file.is_open()) {
        log_content = "Impossible to open file : " + filename;
        return;
    }

    std::ostringstream ss;
    ss << file.rdbuf();
    log_content = ss.str();
}

static void on_overlay_draw(reshade::api::effect_runtime* runtime)
{
    ImGuiStyle& style = ImGui::GetStyle();
    style.ItemSpacing = ImVec2(8 * scale, 8 * scale);     // Spacing between widgets
    style.FramePadding = ImVec2(3 * scale, 3 * scale);    // Widgets padding
    style.WindowPadding = ImVec2(10 * scale, 10 * scale); // Overlay padding
    style.CellPadding = ImVec2(10 * scale, 10 * scale);   // Table cells padding

    ImGui::SetNextWindowSize(ImVec2(350 * scale, 150 * scale), ImGuiCond_Once);

    ImGui::PushStyleColor(ImGuiCol_Button, ImVec4(0.84f, 0.12f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_ButtonHovered, ImVec4(0.84f, 0.12f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_ButtonActive, ImVec4(0.84f, 0.2f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_Text, ImVec4(0.8f, 1.f, 1.f, 1.f)); // white
    if (ImGui::Button("Like my work ? Consider donation")) ShellExecuteA(NULL, "open", DONATION_URL, NULL, NULL, SW_SHOWNORMAL); // Donation
    ImGui::PopStyleColor(4); // Restore color
    ImGui::SameLine();
    if (ImGui::Button("Fix informations")) popup_Informations = true; // Fix information
    ImGui::SameLine();
    if (ImGui::Button("View logs")) {
        read_log_file("CronosTND.log");
        show_log_overlay = true; // Fix information
    }

    if (popup_Informations) {
        ImGui::Begin("Informations", &popup_Informations, ImGuiWindowFlags_AlwaysAutoResize);
        ImGui::Text("Version : %s", FIX_VERSION);
        ImGui::Text(FIX_INFORMATIONS);
        ImGui::End();
    }

    if (show_log_overlay) {
        ImGui::Begin("Game log", &show_log_overlay, ImGuiWindowFlags_AlwaysAutoResize);
        ImGui::TextUnformatted(log_content.c_str());
        ImGui::End();
    }

    if (ImGui::BeginTabBar("MainTabs")) {
        if (ImGui::BeginTabItem("Fixes")) {
            ImGui::PushStyleVar(ImGuiStyleVar_CellPadding, ImVec2(10 * scale, 10 * scale));
            if (ImGui::BeginTable("FixesTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                ImGui::TableSetupColumn("LeftFix", ImGuiTableColumnFlags_WidthStretch, 0.4f);
                ImGui::TableSetupColumn("RightFix", ImGuiTableColumnFlags_WidthStretch, 0.6f);
                ImGui::TableNextRow();

                // Drawing a left column with slider and general fix
                ImGui::TableSetColumnIndex(0);

                // Drawing a left column with slider and general fix
                if (ImGui::CollapsingHeader("Enable fixes", ImGuiTreeNodeFlags_DefaultOpen))
                    if (ImGui::Checkbox("Fix enabled", &fix_enabled)) {
                        if (SetFixEnabled) SetFixEnabled(fix_enabled, false);
                        SaveSettings();
                    }
                // Individual fixes
                ImGui::TableSetColumnIndex(1);
                if (ImGui::CollapsingHeader("Individual fixes", ImGuiTreeNodeFlags_DefaultOpen)) {
                    if (ImGui::BeginTable("IndividualFixesTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                        ImGui::TableSetupColumn("IndFix1", ImGuiTableColumnFlags_WidthStretch, 0.4f);
                        ImGui::TableSetupColumn("IndFix2", ImGuiTableColumnFlags_WidthStretch, 0.6f);
                        ImGui::TableNextRow();

                        ImGui::TableSetColumnIndex(0);
                        for (int i = 0; i < 3; ++i) DrawFixCheckbox(individualFixes[i]);
                        ImGui::TableSetColumnIndex(1);
                        for (int i = 3; i < IM_ARRAYSIZE(individualFixes); ++i) DrawFixCheckbox(individualFixes[i]);
                        ImGui::EndTable();
                    }
                }
                ImGui::EndTable();
            }

            ImGui::SetCursorPosY(ImGui::GetCursorPosY() - 2);
            if (ImGui::BeginTable("FixesSliders", 2, ImGuiTableFlags_SizingStretchSame)) {
                ImGui::TableNextRow();
                ImGui::TableSetColumnIndex(0);
                DrawSlider2(sliders[0], 200);
                DrawSlider2(sliders[1], 200);
                ImGui::TableSetColumnIndex(1);
                DrawSlider2(sliders[2], 200);
                DrawSlider2(sliders[3], 200);
                ImGui::EndTable();
            }
            ImGui::PopStyleVar();
            ImGui::EndTabItem();
        }

        if (ImGui::BeginTabItem("Cheats")) {
            for (const auto& cheat : cheatFixes) DrawFixCheckbox(cheat);

            ImGui::PushStyleVar(ImGuiStyleVar_CellPadding, ImVec2(10 * scale, 10 * scale));
            if (ImGui::BeginTable("SlidersTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                ImGui::TableSetupColumn("LeftSliders", ImGuiTableColumnFlags_WidthStretch, 0.5f);
                ImGui::TableSetupColumn("RightSliders", ImGuiTableColumnFlags_WidthStretch, 0.5f);
                ImGui::TableNextRow();

                ImGui::TableSetColumnIndex(0);
                DrawSlider2(sliders[4], 180);
                ImGui::TableSetColumnIndex(1);
                DrawSlider2(sliders[5], 180);
                ImGui::EndTable();
            }
            ImGui::PopStyleVar();
            ImGui::EndTabItem();
            if (ImGui::CollapsingHeader("Cheat informations", ImGuiTreeNodeFlags_DefaultOpen)) {
                if (GetGameInfos) {
                    GameInfos infos{};
                    GetGameInfos(&infos);
                    ImGui::TextColored(ImColor(48, 179, 25), "Traveler health: %.2f", infos.Health);
                }
            }
        }
        ImGui::EndTabBar();

        // Fix status
        if (ImGui::CollapsingHeader("Fix informations", ImGuiTreeNodeFlags_DefaultOpen)) {
            ImGui::Text("Screen width: %d, height: %d, aspect ratio: %.2f", screenWidth, screenHeight, aspectRatio);
            if (GetGameInfos) {
                GameInfos infos{};
                GetGameInfos(&infos);
                if (infos.consoleEnabled)
                    ImGui::Text("Console enabled and bound to key F2");
                ImGui::TextColored(ImColor(48, 179, 25), "FOV In: %.2f, Compensated: %.2f, Out: %.2f", infos.FOVIn, infos.CompensatedFOV, infos.FOVOut);
                ImGui::TextColored(ImColor(48, 179, 25), "Camera distance In: %.2f, Out: %.2f", infos.cameraIn, infos.cameraOut);
            }
        }
    }
}

static void on_reshade_present(reshade::api::effect_runtime* runtime) {
    static auto last = std::chrono::steady_clock::now();
    auto now = std::chrono::steady_clock::now();
    float dt = std::chrono::duration<float>(now - last).count();
    last = now;

    ProcessHotkeys(runtime);
    UpdateOSD(runtime, dt);
}

// Retrieve all shader uniform variables
static void on_reshade_begin_effects(reshade::api::effect_runtime* runtime, reshade::api::command_list* cmd_list,
    reshade::api::resource_view rtv, reshade::api::resource_view rtv_srgb) {
    if (!runtime) return;
    FindAllUniformVariables(runtime, OSD_SHADER_NAME); // Find all uniforms and set their handle

    if (InterlockedCompareExchange(&g_uniformReseted, 1, 0) != 0) return; // reset OSD uniforms once
    ResetAllUniformVariables(runtime, OSD_SHADER_NAME);
    runtime->save_current_preset(); // Save shader preset
}

static void InitializeHotkeys() { // Initialize hotkeys for cheats
    if (InterlockedCompareExchange(&g_hotkeysInitialized, 1, 0) != 0) return; // Initialize hotkeys once

    RegisterHotkey('1', Modifier::Alt, [] {
        ToggleOSD(Time_Dilation_fix_enabled, GameFixes::TimeDilation,
            u_td_show, u_td_enabled, OSD_duration,
            { {u_td_world, worldTimeDilationValue}, {u_td_AI, AITimeDilationValue} });
        });
    RegisterHotkey('2', Modifier::Alt, [] { ToggleOSD(GodMode_fix_enabled, GameFixes::GodMode, u_GodMode_show, u_GodMode_enabled, OSD_duration); });
    RegisterHotkey('3', Modifier::Alt, [] { ToggleOSD(Ignore_hits_fix_enabled, GameFixes::IgnoreHits, u_IgnoreHits_show, u_IgnoreHits_enabled, OSD_duration); });
    RegisterHotkey('4', Modifier::Alt, [] { ToggleOSD(StealthMode_fix_enabled, GameFixes::Stealth, u_Stealth_show, u_Stealth_enabled, OSD_duration); });
}

// Main dll intrance
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD ul_reason_for_call, LPVOID) {
    switch (ul_reason_for_call) {
        case DLL_PROCESS_ATTACH:
            if (!reshade::register_addon(hinstDLL))
                return FALSE;
            LoadSettings();

            reshade::register_overlay("Cronos: The New Dawn", &on_overlay_draw);
            reshade::register_event<reshade::addon_event::init_effect_runtime>(
                [](reshade::api::effect_runtime* runtime) {
                    LoadFixDLL();
                    InitializeHotkeys();
                });
            reshade::register_event<reshade::addon_event::reshade_present>(&on_reshade_present);
            reshade::register_event<reshade::addon_event::reshade_begin_effects>(&on_reshade_begin_effects);
            break;
        case DLL_PROCESS_DETACH:
            reshade::unregister_event<reshade::addon_event::reshade_present>(&on_reshade_present);
            reshade::unregister_event<reshade::addon_event::reshade_begin_effects>(&on_reshade_begin_effects);
            reshade::unregister_addon(hinstDLL);
            break;
    }
    return TRUE;
}